; Lscht das serielle EEPROM 24C04 auf dem seriellen 80C552-Board.
; Leitung SDA an Port 3.4, SCL an Port 3.5, WP an Port 3.3
; Die Eingnge A0, A1, A2 sind an Masse.
; Das Ergebnis ist mit dem Programm 24c04b.a51 auslesbar.

#cpu = 80C552	; @16 MHz

#Const Schreiben in Block 0 = 1010 0000b
#Const Schreiben in Block 1 = 1010 0010b
#Bit Data = P3.4, CLK = P3.5, WP = P3.3

Reset:
	clr WP	; Write protect
	r0 = #FFh	; zu schreibender Wert
	r4 = #0		; Adresszhler, wird in 8er Schritten erhht.
	r5 = #Schreiben in Block 0
	Block lschen
	r5 = #Schreiben in Block 1
	Block lschen
	P1 = #AAh		; signalisiert das Ende.
end

Block lschen:
	loop
		Startbedingung erzeugen
		a = r5: 8 Bits senden	; Device Select Byte
		a = r4: 8 Bits senden	; Startadresse
		for r3 = #8
			a = r0: 8 Bits senden	; EEPROM fllen
		next
		Stoppbedingung erzeugen	; startet den Brennvorgang.

		; auf Beendigung des Brennvorgangs warten:
		loop
			Startbedingung erzeugen
			a = r5: 8 Bits senden
		until not bit c
		a = r4: add a, #8: r4 = a
	until r4 = #0
ret

Startbedingung erzeugen:
	setb CLK: >5s
	clr Data: >5s
	clr CLK
ret

Stoppbedingung erzeugen:
	clr Data: >5s
	setb CLK: >5s
	setb Data
ret

8 Bits senden:		;Daten sind in a
	for r2 = #8
		rlc a: Data = c
		Takt
	next		
; Acknowledge lesen:
	setb Data: >5s
	setb CLK: >5s
	c = Data: >5s	; c = 0 ist erfolgreiche Operation.
	clr CLK: >5s
ret

Takt:
	>5s: setb CLK	;Low-Pegel
	>5s: clr CLK	;High-Pegel
ret

>5s:		;Dient der Zeitverzgerung (@16 MHz)
ret