; 29.04.02 17:32:20

#cpu = 80C552	; @16 MHz

ajmp Initialisierung

S1:	; IC Interrupt, funktioniert nur mit angeschlossenen Pullups
ajmp IC Interrupt

Initialisierung:
; Interrupts
setb ES1	; IC Interrupt freigeben
setb EA	; globale Interruptfreigabe
; IC-Bus
setb SCL
setb SDA
;mov S1CON, #60h	; ENS1 = 1, IC-Taktrate im Mastermodus ist 62,5 kHz. Startbedingung ausgeben (setzt Bit STA)
mov S1CON, #44h	;60h	; ENS1 = 1, IC-Taktrate im Mastermodus ist 62,5 kHz. Startbedingung ausgeben (setzt Bit STA)
setb STA	; Startbedingung ausgeben

end
; * * * Hauptprogramm Ende * * *

IC Interrupt:
	mov dptr, #IC Serviceroutine
	mov a, S1STA
	jmp @a+dptr

IC Serviceroutine:
	; Status 00: Bus Error
	; Befehle..
reti

org IC Serviceroutine + 8
	; Status 08: eine Startbedingung wurde gesendet
	; Befehle..
	if bit STA then
		mov p4, #FEh
	else	
		mov p4, # 'S'
	end if
	end
reti

org IC Serviceroutine + 10h
	; Status 10h: eine wiederholte Startbedingung wurde gesendet
	; Befehle..
reti
nop
nop

org IC Serviceroutine + 18h
	; Status 18h: Slave-Adresse + Write wurde gesendet, ACK-Signal wurde empfangen
	; Befehle..
reti

org IC Serviceroutine + 20h
	; Status 20h: Slave-Adresse + Write wurde gesendet, es wurde kein ACK-Signal empfangen
	; Befehle..
reti

org IC Serviceroutine + 28h
	; Status 28h: ein Datenbyte wurde gesendet, ACK-Signal wurde empfangen
	; Befehle..
reti

org IC Serviceroutine + 30h
	; Status 30h: ein Datenbyte wurde gesendet, es wurde kein ACK-Signal empfangen
	; Befehle..
reti

org IC Serviceroutine + 38h
	; Status 38h: Buskontrolle ging beim Schreiben/Lesen der Slave-Adresse oder eines Datenbytes verloren
	; Befehle..
reti

org IC Serviceroutine + 40h
	; Status 40h: Slave-Adresse + Read wurde gesendet, ACK-Signal wurde empfangen
	; Befehle..
reti

org IC Serviceroutine + 48h
	; Status 48h: Slave-Adresse + Read wurde gesendet, es wurde kein ACK-Signal empfangen
	; Befehle..
reti

org IC Serviceroutine + 50h
	; Status 50h: ein Datenbyte wurde empfangen, ACK-Signal wurde empfangen
	; Befehle..
reti

org IC Serviceroutine + 58h
	; Status 58h: ein Datenbyte wurde empfangen, es wurde kein ACK-Signal empfangen
	; Befehle..
reti

org IC Serviceroutine + 60h
	; Status 60h: die eigene Slave-Adresse + Write wurde empfangen, ACK-Signal wurde gesendet
	; Befehle..
reti

org IC Serviceroutine + 68h
	; Status 68h: Buskontrolle ging verloren beim Schreiben/Lesen der Slave-Adresse als Master, die eigene Slave-Adresse + Write wurde empfangen, ACK-Signal wurde gesendet
	; Befehle..
reti

org IC Serviceroutine + 70h
	; Status 70h: die General call Adresse (00) wurde empfangen, ACK-Signal wurde gesendet
	; Befehle..
reti

org IC Serviceroutine + 78h
	; Status 78h: Buskontrolle ging verloren beim Schreiben/Lesen der Slave-Adresse als Master, die eigene Slave-Adresse + Write wurde empfangen, ACK-Signal wurde gesendet
	; Befehle..
reti

org IC Serviceroutine + 80h
	; Status 80h: ein Datenbyte wurde nach der Adressierung mit der eigenen Slave-Adresse empfangen, ACK-Signal wurde gesendet
	; Befehle..
reti

org IC Serviceroutine + 88h
	; Status 88h: ein Datenbyte wurde nach der Adressierung mit der eigenen Slave-Adresse empfangen, es wurde kein ACK-Signal gesendet
	; Befehle..
reti

org IC Serviceroutine + 90h
	; Status 90h: ein Datenbyte wurde nach einer General Call Adressierung empfangen, ACK-Signal wurde gesendet
	; Befehle..
reti

org IC Serviceroutine + 98h
	; Status 98h: ein Datenbyte wurde nach einer General Call Adressierung empfangen, es wurde kein ACK-Signal gesendet
	; Befehle..
reti

org IC Serviceroutine + A0h
	; Status A0h: eine Stop- oder wiederholte Startbedingung wurde im Slave-Receiver bzw. Slave-Transmitter Modus empfangen 
	; Befehle..
reti

org IC Serviceroutine + A8h
	; Status A8h: die eigene Slave-Adresse + Read wurde empfangen, ACK-Signal wurde gesendet
	; Befehle..
reti

org IC Serviceroutine + B0h
	; Status B0h: die Buskontrolle ging bei der Slave-Adressierung als Master verloren, die eigene Slave-Adresse wurde empfangen + Read, ACK-Signal wurde gesendet
	; Befehle..
reti

org IC Serviceroutine + B8h
	; Status B8h: Datenbyte wurde gesendet, ACK-Signal wurde empfangen
	; Befehle..
reti

org IC Serviceroutine + C0h
	; Status C0h: Datenbyte wurde gesendet, es wurde kein ACK-Signal empfangen
	; Befehle..
reti

org IC Serviceroutine + C8h
	; Status C8h: das letzte Datenbyte wurde gesendet (AA = 0), ACK-Signal wurde empfangen
	; Befehle..
reti

nop: nop